#pragma once
namespace YoggieEngine{
/*
* Based on GLFW 
*/

/* The unknown key */
#define YOGGIE_KEY_UNKNOWN            -1

/* Printable keys */
#define YOGGIE_KEY_SPACE              32
#define YOGGIE_KEY_APOSTROPHE         39  /* ' */
#define YOGGIE_KEY_COMMA              44  /* , */
#define YOGGIE_KEY_MINUS              45  /* - */
#define YOGGIE_KEY_PERIOD             46  /* . */
#define YOGGIE_KEY_SLASH              47  /* / */
#define YOGGIE_KEY_0                  48
#define YOGGIE_KEY_1                  49
#define YOGGIE_KEY_2                  50
#define YOGGIE_KEY_3                  51
#define YOGGIE_KEY_4                  52
#define YOGGIE_KEY_5                  53
#define YOGGIE_KEY_6                  54
#define YOGGIE_KEY_7                  55
#define YOGGIE_KEY_8                  56
#define YOGGIE_KEY_9                  57
#define YOGGIE_KEY_SEMICOLON          59  /* ; */
#define YOGGIE_KEY_EQUAL              61  /* = */
#define YOGGIE_KEY_A                  65
#define YOGGIE_KEY_B                  66
#define YOGGIE_KEY_C                  67
#define YOGGIE_KEY_D                  68
#define YOGGIE_KEY_E                  69
#define YOGGIE_KEY_F                  70
#define YOGGIE_KEY_G                  71
#define YOGGIE_KEY_H                  72
#define YOGGIE_KEY_I                  73
#define YOGGIE_KEY_J                  74
#define YOGGIE_KEY_K                  75
#define YOGGIE_KEY_L                  76
#define YOGGIE_KEY_M                  77
#define YOGGIE_KEY_N                  78
#define YOGGIE_KEY_O                  79
#define YOGGIE_KEY_P                  80
#define YOGGIE_KEY_Q                  81
#define YOGGIE_KEY_R                  82
#define YOGGIE_KEY_S                  83
#define YOGGIE_KEY_T                  84
#define YOGGIE_KEY_U                  85
#define YOGGIE_KEY_V                  86
#define YOGGIE_KEY_W                  87
#define YOGGIE_KEY_X                  88
#define YOGGIE_KEY_Y                  89
#define YOGGIE_KEY_Z                  90
#define YOGGIE_KEY_LEFT_BRACKET       91  /* [ */
#define YOGGIE_KEY_BACKSLASH          92  /* \ */
#define YOGGIE_KEY_RIGHT_BRACKET      93  /* ] */
#define YOGGIE_KEY_GRAVE_ACCENT       96  /* ` */
#define YOGGIE_KEY_WORLD_1            161 /* non-US #1 */
#define YOGGIE_KEY_WORLD_2            162 /* non-US #2 */

/* Function keys */
#define YOGGIE_KEY_ESCAPE             256
#define YOGGIE_KEY_ENTER              257
#define YOGGIE_KEY_TAB                258
#define YOGGIE_KEY_BACKSPACE          259
#define YOGGIE_KEY_INSERT             260
#define YOGGIE_KEY_DELETE             261
#define YOGGIE_KEY_RIGHT              262
#define YOGGIE_KEY_LEFT               263
#define YOGGIE_KEY_DOWN               264
#define YOGGIE_KEY_UP                 265
#define YOGGIE_KEY_PAGE_UP            266
#define YOGGIE_KEY_PAGE_DOWN          267
#define YOGGIE_KEY_HOME               268
#define YOGGIE_KEY_END                269
#define YOGGIE_KEY_CAPS_LOCK          280
#define YOGGIE_KEY_SCROLL_LOCK        281
#define YOGGIE_KEY_NUM_LOCK           282
#define YOGGIE_KEY_PRINT_SCREEN       283
#define YOGGIE_KEY_PAUSE              284
#define YOGGIE_KEY_F1                 290
#define YOGGIE_KEY_F2                 291
#define YOGGIE_KEY_F3                 292
#define YOGGIE_KEY_F4                 293
#define YOGGIE_KEY_F5                 294
#define YOGGIE_KEY_F6                 295
#define YOGGIE_KEY_F7                 296
#define YOGGIE_KEY_F8                 297
#define YOGGIE_KEY_F9                 298
#define YOGGIE_KEY_F10                299
#define YOGGIE_KEY_F11                300
#define YOGGIE_KEY_F12                301
#define YOGGIE_KEY_F13                302
#define YOGGIE_KEY_F14                303
#define YOGGIE_KEY_F15                304
#define YOGGIE_KEY_F16                305
#define YOGGIE_KEY_F17                306
#define YOGGIE_KEY_F18                307
#define YOGGIE_KEY_F19                308
#define YOGGIE_KEY_F20                309
#define YOGGIE_KEY_F21                310
#define YOGGIE_KEY_F22                311
#define YOGGIE_KEY_F23                312
#define YOGGIE_KEY_F24                313
#define YOGGIE_KEY_F25                314
#define YOGGIE_KEY_KP_0               320
#define YOGGIE_KEY_KP_1               321
#define YOGGIE_KEY_KP_2               322
#define YOGGIE_KEY_KP_3               323
#define YOGGIE_KEY_KP_4               324
#define YOGGIE_KEY_KP_5               325
#define YOGGIE_KEY_KP_6               326
#define YOGGIE_KEY_KP_7               327
#define YOGGIE_KEY_KP_8               328
#define YOGGIE_KEY_KP_9               329
#define YOGGIE_KEY_KP_DECIMAL         330
#define YOGGIE_KEY_KP_DIVIDE          331
#define YOGGIE_KEY_KP_MULTIPLY        332
#define YOGGIE_KEY_KP_SUBTRACT        333
#define YOGGIE_KEY_KP_ADD             334
#define YOGGIE_KEY_KP_ENTER           335
#define YOGGIE_KEY_KP_EQUAL           336
#define YOGGIE_KEY_LEFT_SHIFT         340
#define YOGGIE_KEY_LEFT_CONTROL       341
#define YOGGIE_KEY_LEFT_ALT           342
#define YOGGIE_KEY_LEFT_SUPER         343
#define YOGGIE_KEY_RIGHT_SHIFT        344
#define YOGGIE_KEY_RIGHT_CONTROL      345
#define YOGGIE_KEY_RIGHT_ALT          346
#define YOGGIE_KEY_RIGHT_SUPER        347
#define YOGGIE_KEY_MENU               348

#define YOGGIE_KEY_LAST               YOGGIE_KEY_MENU
/*
* Modifier keys 
*/
 // If set one or more Shift keys were held down.
#define YOGGIE_MOD_SHIFT           0x0001
//If set one or more Control keys were held down.
#define YOGGIE_MOD_CONTROL         0x0002

// If set one or more Alt keys were held down.
#define YOGGIE_MOD_ALT             0x0004

// SuperKey(s) (if set, One or more superkeys is held down)
#define YOGGIE_MOD_SUPER           0x0008

// Capslock (if set, Capslock is enabeld)
#define YOGGIE_MOD_CAPS_LOCK       0x0010

// Numlock (if set, numlock is enabled)
#define YOGGIE_MOD_NUM_LOCK        0x0020

/*
* Mouse Keys
*/
#define YOGGIE_MOUSE_BUTTON_1         0
#define YOGGIE_MOUSE_BUTTON_2         1
#define YOGGIE_MOUSE_BUTTON_3         2
#define YOGGIE_MOUSE_BUTTON_4         3
#define YOGGIE_MOUSE_BUTTON_5         4
#define YOGGIE_MOUSE_BUTTON_6         5
#define YOGGIE_MOUSE_BUTTON_7         6
#define YOGGIE_MOUSE_BUTTON_8         7
#define YOGGIE_MOUSE_BUTTON_LAST      YOGGIE_MOUSE_BUTTON_8
#define YOGGIE_MOUSE_BUTTON_LEFT      YOGGIE_MOUSE_BUTTON_1
#define YOGGIE_MOUSE_BUTTON_RIGHT     YOGGIE_MOUSE_BUTTON_2
#define YOGGIE_MOUSE_BUTTON_MIDDLE    YOGGIE_MOUSE_BUTTON_3
}